unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer; 
      aState: TGridDrawState);
    procedure StringGrid1Selection(Sender: TObject; aCol, aRow: Integer);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer; 
  aState: TGridDrawState);
var
  r: Integer;
begin
  if (aCol > 0) then
  begin
    r := StringGrid1.Row;
    if ((r >= 1) and (r <= 3)) or ((r >= 5) and (r <= 7)) then
    begin
      if (ARow = r) or (ARow = r + 4) or (ARow = r - 4) or (ARow = 9) then
      begin
        StringGrid1.Canvas.Brush.Color := clHighlight;
        StringGrid1.Canvas.Font.Color := clHighlightText;
      end;
    end;
  end;
end;

procedure TForm1.StringGrid1Selection(Sender: TObject; aCol, aRow: Integer);
var
  c, r: Integer;
  x1, x2: Integer;
begin
  r := -1;
  if (ARow >= 1) and (ARow <= 3) then
    r := ARow + 4;
  if (ARow >= 5) and (ARow <= 7) then
    r := ARow - 4;
  
  if r = -1 then
  begin
    StringGrid1.Rows[9].Clear;
    StringGrid1.Cells[0, 9] := 'Summe';
    StringGrid1.Invalidate;
    exit;
  end;
  
  for c := 1 to StringGrid1.ColCount-1 do
  begin
    x1 := StrToInt(StringGrid1.Cells[c, ARow]);
    x2 := StrToInt(StringGrid1.Cells[c, r]);
    StringGrid1.Cells[c, 9] := IntToStr(x1+x2);
  end;

  StringGrid1.Invalidate;
end;

end.

